Skip Headers

Oracle® Database Platform Guide 10g Release 2 (10.2) for Microsoft Windows (64-Bit) on Intel Itanium Part Number B14305-02 |
Home | Book List | Contents | Master Index | Feedback

Previous | Next
| View PDF

Beta Draft

# 14 Configuration Parameters and the Registry

This chapter describes use of the registry for various Oracle Database for Windows components. It also lists recommended values and ranges for configuration parameters.

This chapter contains these topics:

- About Configuration Parameters

- Registry Overview

- Registry Parameters

- Oracle Real Application Clusters Registry Parameters

- Managing Registry Parameters with regedt

- Managing Registry Parameters with Oracle Administration Assistant for Windows

- Modifying Oracle Counters for Windows Performance Monitor Parameters

## 14.1 About Configuration Parameters

Oracle Database for Windows uses configuration parameters to locate files and specify runtime parameters common to all Oracle products. When an Oracle program or application requires a translation for a particular configuration variable, Oracle Database for Windows uses the associated parameter. All Oracle parameters are stored in the registry.

## 14.2 Registry Overview

Oracle Database for Windows stores its configuration information in a repository (the registry) that is organized in a tree format. The tree format consists of keys in the registry and parameter values for the keys. Keys and parameter values can be viewed and modified in Registry Editor.

Keys are folders that appear in the left pane of a Registry Editor window. A key contains subkeys or parameters.

Caution: Although Registry Editor lets you view and modify registry keys and parameter values, you normally are not required to do so. In fact, you can render your system useless if you make incorrect changes. Therefore, only advanced users should edit the registry! Back up your system before making any changes in the registry.

Parameters in Registry Editor appear as a string, consisting of three components:

- Parameter name

- Value class or type of entry

- Value itself

For example, parameter `ORACLE_SID` can have the following entry in the registry:

    ORACLE_SID:reg_sz:orcl1

Value classes for Oracle Database for Windows parameters are:

- String value with a `REG_SZ`, `REG_EXPAND_SZ` (for an expandable string), or a `REG_MULTI_SZ` (for multiple strings) prefix to identify a parameter value entry as a data string

- Binary value with a `REG_DWORD` prefix to identify a value entry as a `dword` (hexadecimal data) entry

Most Oracle Database for Windows parameter values are string types. Use Oracle Universal Installer defaults when a type is not given.

## 14.3 Registry Parameters

This section describes Oracle Database for Windows registry parameters for the following keys. Other products, such as Oracle Enterprise Manager, have additional keys and parameters that are not described in this chapter.

- HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_HOME_NAME

- HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE

- HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services

Note: Oracle Database for 64-bit Windows has additional configuration parameters that enable and control large page support. See "Large Page Support".

To modify these registry values, see "Managing Registry Parameters with regedt".

### 14.3.1 HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_HOME_NAME

Each time you install Oracle products into a new Oracle home on your computer, `HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_``HOME_NAME` is created. This subkey contains parameter values for most Oracle products.

Note: See Appendix B, "Optimal Flexible Architecture", in Oracle Database Installation Guide for Microsoft Windows (64-Bit) on Intel Itanium for details on the PATH variable and registry values when you are working with multiple Oracle homes.

`HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_``HOME_NAME` includes the following parameters for an Oracle home directory. Depending on products you install, additional parameters can also be created. See your Windows development manuals.

#### 14.3.1.1 MSHELP_TOOLS

Specifies the location of Windows help files. The default value is

    ORACLE_BASE\ORACLE_HOME\mshelp

#### 14.3.1.2 NLS_LANG

Specifies supported language, territory, and character set. This parameter specifies the language in which messages appear, the territory and its conventions for calculating week and day numbers, and the character set displayed. Oracle Universal Installer sets this value during installation based on the language setting of the operating system. See Oracle Database Globalization Support Guide for a list of values.

#### 14.3.1.3 ORA_CWD

Specifies current working directory. For example, if you set this parameter and then use ORADIM, a log file called `oradim.log` is created in this directory. This parameter must be manually set.

#### 14.3.1.4 ORA_SID_AUTOSTART

Starts Oracle Database when `OracleService` `SID` service is started. The default value is `true.`

#### 14.3.1.5 ORA_SID_PFILE

Specifies full path to initialization parameter file. The default value is `ORACLE_BASE``\admin\DB_NAME\pfile\init.ora`

#### 14.3.1.6 ORA_SID_SHUTDOWN

When set to `true`, the default value, this parameter shuts down the instance of Oracle Database identified by `SID` when `OracleService` `SID` is stopped manually—using either the Control Panel or Net stop command.

#### 14.3.1.7 ORA_SID_SHUTDOWN_TIMEOUT

Sets maximum time (in seconds) to wait for shutdown to complete before the service for a particular SID stops. The default value is `30`.

#### 14.3.1.8 ORA_SID_SHUTDOWNTYPE

Specifies mode in which Oracle Database is shut down when you stop `OracleService` `SID`. Valid values are `a` (abort), `i` (immediate), and `n` (normal). The default value is `i`.

#### 14.3.1.9 ORA_TZFILE

Specifies location of time zone file. Each file contains:

- Valid time zone names

- Offset from UTC

- Abbreviation for standard time

- Abbreviation for daylight savings time

In previous releases, the default value for `ORA _TZFILE` was

    ORACLE_BASE\ORACLE_HOME\oracore\zoneinfo\timezone.dat

Beginning with Oracle Database 10g Release 1 (10.1), the default value is

    ORACLE_BASE\ORACLE_HOME\oracore\zoneinfo\timezlrg.dat

The former default, `timezone.dat`, contains most commonly used time zones and is smaller for better database performance. The new default, `timezlrg.dat`, includes time zones not defined in the smaller file. To enable use of the smaller file, the database administrator must:

1. Shut down Oracle Database.

2. Set `ORA_TZFILE` to the full path name of the location of `timezone.dat` file.

3. Restart Oracle Database.

To view time zone names, use SQL*Plus to make the following query:

    SELECT * from v$timezone_names

If the larger `timezlrg.dat` file is used, then it must stay in use unless the user is sure that no data uses one of the added time zones. Also, all databases that share information must use the same time zone file.

See Also: Oracle Database Globalization Support Guide for lists of time zone names for both time zone files

#### 14.3.1.10 ORACLE_AFFINITY

Specifies Windows processor affinity of each thread within the Oracle Database process. This parameter must be manually added. Oracle recommends consulting Oracle Support Services before changing this parameter. The format is:

    name1:cpumask1;name2:cpumask2

Each `name` setting must be the name of a background thread, `user` for non-background (shadow) threads, or `def` for any thread type not handled specifically.

The `name` mask sets the affinity mask of the Oracle Database process. Valid background thread names include `DBW0`, `LGWR`, `PMON`, `SMON`, `ARCH`, `RECO`, `CKPT`, `TRWR`, `SNP0` through `SNP9`, `P000` through `P481`, and any other name found in the `NAME` column of the `v$bgprocess` data dictionary view.

Each affinity setting must be a valid affinity mask (or its numeric equivalent) for the corresponding name. Process affinity masks are used only when Oracle services are first started. Each thread's affinity is set only when the individual thread is started (for example, at database startup time for the background threads).

#### 14.3.1.11 ORACLE_BASE

Specifies the top-level Oracle directory (for example, `C:\oracle\product\10.2.0`) that contains `ORACLE_HOME`, `admin`, and `oradata`. The default is `ORACLE_BASE`.

#### 14.3.1.12 ORACLE_GROUP_NAME

Specifies the name of the group containing icons of the Oracle products installed. The parameter is added to your registry when you first install Oracle products, even if Oracle Universal Installer does not create a program group for Oracle products you have installed (for example, if you have installed only Oracle Net software). The default value is `Oracle` `-` `HOME_NAME`.

#### 14.3.1.13 ORACLE_HOME

Specifies Oracle home directory in which Oracle products are installed. This directory is immediately beneath the Oracle base directory in the Oracle directory hierarchy. The default value is the drive letter and name that you specify during installation.

#### 14.3.1.14 ORACLE_HOME_KEY

The `HKEY_LOCAL_MACHINE` location of Oracle parameters. The default value is `software\oracle\HOME` `ID.`

#### 14.3.1.15 ORACLE_HOME_NAME

Specifies home name of Oracle home directory in which Oracle products are installed. The default value is the name that you specify during installation.

#### 14.3.1.16 ORACLE_PRIORITY

Determines Windows scheduling priorities of threads within the Oracle Database management system process. The format is:

    name1:priority1;name2:priority2 . . .

The `name` class sets the `priority` class of the Oracle Database process. Threads can be assigned priority either collectively or individually. The collective name `user` designates non-background (shadow) threads; the collective name `def` designates any thread type not handled specifically. Valid individual background thread names include `DBW0`, `LGWR`, `PMON`, `SMON`, `ARCH0`, `RECO`, `CKPT`, `TRWR`, `SNP0` through `SNP9`, and any other name found in the `NAME` column of the `v$bgprocess` data dictionary view.

The default value is `class:normal; def:normal`.

Note: `ORACLE_PRIORITY` is not automatically created for you in the registry. When it is not defined in the registry, Windows default values are used for thread priorities.

#### 14.3.1.17 ORACLE_SID

Specifies the name of the Oracle Database instance on the host computer. The value of this parameter is the SID for the instance. The default value is specified by the entry in the Database Identification window of Oracle Universal Installer.

#### 14.3.1.18 OSAUTH_ENFORCE_STRICT

Specifies if an operating system user must belong to an authorized group to connect using operating system authentication, in addition to the normal operating system authentication checking and permission lookup.

If the value of this entry is `true`, then the user must belong to one of the following local groups on the Windows computer to connect using operating system authentication:

- `ORA_DBA`

- `ORA_sid_DBA`

- `ORA_OPER`

- `ORA_sid_OPER`

- `ORA_USER`

- `ORA_sid_USER`

The default value is `false`.

The preceeding parameter entry was added on Nov. 16th, 2005 in order to close bug #2598595.

#### 14.3.1.19 OSAUTH_PREFIX_DOMAIN

Enables user authentication. When it is set to `true`, it enables the server to differentiate between one username and another, whether they are local users, domain users, or domain users on another domain in your network. When it is set to `false`, the domain is ignored, and the local user becomes the default value of the operating system user returned to the server. The default value is `false`.

#### 14.3.1.20 OSAUTH_X509_NAME

Enables client users to access Oracle Database as X.509-compliant enterprise users. This parameter is required only if you want to use enterprise users and roles in an Oracle Database computer running in a Windows 2000 domain. The default value is `false`.

#### 14.3.1.21 RDBMS_ARCHIVE

Specifies the location of backup database files. The default value is `ORACLE_BASE``\``ORACLE_HOME``\database\archive`.

#### 14.3.1.22 RDBMS_CONTROL

Specifies the location of backup database control files. The default value is `ORACLE_BASE``\``ORACLE_HOME``\database`.

#### 14.3.1.23 SQLPATH

Specifies the location of SQL scripts. The default value is `ORACLE_BASE``\``ORACLE_HOME``\dbs`.

### 14.3.2 HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE

This subkey contains the following parameters:

#### 14.3.2.1 INST_LOC

Specifies the location of Oracle Universal Installer files. The default value is `System Drive``:\program files\oracle\inventory.`

#### 14.3.2.2 OO4O

Specifies the location of Oracle Objects for OLE message files. The default value is `ORACLE_BASE``\``ORACLE_HOME``\oo4o\mesg.`

### 14.3.3 HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services

`HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet` contains four keys:

- Control

- Enum

- HardwareProfiles

- Services

The first three are used by the operating system. You can edit only the `Services` subkey, which contains:

- Parameters for Oracle Counters for Windows Performance Monitor

- Parameters for Oracle Database Services

#### 14.3.3.1 Parameters for Oracle Counters for Windows Performance Monitor

Oracle Counters for Windows Performance Monitor parameters appear in:

    HKEY_LOCAL_MACHINE\SYSTEM\CURRENTCONTROLSET\SERVICES\ORACLEver\PERFORMANCE

where `ORACLE` `ver` refers to whatever version of Oracle Database is installed.

For multiple Oracle homes compliance starting with Oracle Database 10g Release 1 (10.1), parameters `Hostname`, `Username`, `Password`, `LOGFILE`, and `PERF_FILE_NAME` have been moved to

    HKEY_LOCAL_MACHINE\SYSTEM\CURRENTCONTROLSET\SERVICES\ORACLEver\PERFORMANCE\KEY_HOME_NAME.

Note: Modify only the `Hostname`, `Password`, and `Username` values to point to any database. Oracle recommends that you use operfcfg. See "Using operfcfg".

For Oracle Counters for Windows Performance Monitor to display information for Oracle Database performance objects, it must log in to the database. Modify the following parameters if the default information is not applicable or if you want to access another database:

- `Hostname` displays the SID of the database that Oracle Counters for Windows Performance Monitor will connect to. The default value is blank, causing Oracle Counters for Windows Performance Monitor to connect to the default database on the computer.

  If you specify a different SID, you must also add a connect descriptor for that SID to your `tnsnames.ora` file. Oracle recommends that you use Oracle Net Configuration Assistant, but you can also copy, paste, and modify the following example:

      SERVICE_NAME =
        (DESCRIPTION =
          (ADDRESS_LIST =
            (ADDRESS = (PROTOCOL = TCP)(HOST = HOST_NAME)(PORT = 1521))
          )
          (CONNECT_DATA =
            (SERVER = DEDICATED)
            (SERVICE_NAME = SERVICE_NAME)
          )
        )

- `Password` displays the encrypted password for the username to access the database. The default value is `MANAGER` (encrypted).

- `Username` displays the username to access the database. The default value is `SYSTEM`.

Oracle Counters for Windows Performance Monitor requires the following parameters as entry points:

- `Close` specifies the close entry point for the DLL. The default value is `CloseOracle` `ver` `PerformanceData`.

- `Collect` specifies the collect entry point for the DLL. The default value is `CollectOracle` `ver` `PerformanceData`.

- `Library` specifies the name of the Oracle Counters for Windows Performance Monitor DLL. The default value is `ORAPERF` `ver``.dll`

- `Open` specifies the open entry point for the DLL. The default value is `OpenOracle` `ver` `PerformanceData`.

The following parameters specify Oracle Counters for Windows Performance Monitor log file and object configuration files:

- `LOGFILE` specifies the name of the Oracle Counters for Windows Performance Monitor log file. This log file reports any errors, such as Oracle Database objects not appearing or database access problems. The default value is `ORACLE_BASE``\``ORACLE_HOME``\dbs\operf` `ver`.`log`.

- `PERF_FILE_NAME` specifies the location of the `PERF` `ver``.ora` file, which contains all performance objects displayed by Oracle Counters for Windows Performance Monitor. The default value is `ORACLE_BASE``\``ORACLE_HOME``\dbs\perf` `ver``.ora`

#### 14.3.3.2 Parameters for Oracle Database Services

`HKEY_LOCAL_MACHINE\SYSTEM\CURRENTCONTROLSET\SERVICES` subkey contains additional subkeys that correspond to each Oracle Database service.

Each service subkey contains the following parameters:

- `DisplayName` specifies the service name of the instance whose `SID` is `SID`. The default value is the name of the service. For example, `OracleServiceORCL1`, where `ORCL1` is the `SID`.

- `ImagePath` specifies the fully qualified path name of the executable started by the service and any command-line arguments passed into the executable at runtime. The default value is the path to the executable file of the product.

- `ObjectName` specifies the logon user account and computer to which the service should log on. The default value is `LocalSystem`.

## 14.4 Oracle Real Application Clusters Registry Parameters

Oracle Real Application Clusters registry values are based on the clusterware. If you are not using the clusterware, then some of this information may not be applicable to your particular cluster environment.

### 14.4.1 HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\OCR

This subkey contains the following values:

- `OCRROOT` points to the location of the Oracle Cluster Registry file

- `LOCAL_ONLY` which is set to `False` for a cluster installation and `True` for a single-instance database installation

## 14.5 Managing Registry Parameters with regedt

Caution: Do not edit your registry unless absolutely necessary. If an error occurs in your registry, then Oracle Database for Windows can stop functioning, and the registry itself can become unusable.

### 14.5.1 Modifying a Parameter Value with regedt

To edit Oracle-related settings:

1. Start Registry Editor in one of two ways:

   - From the command prompt, enter:

         C:\> regedt

   - Choose Start `>` Run, enter `regedt` in the Open field, and click OK.

   The Registry Editor window appears.

2. Navigate to the values you want to view or modify by double-clicking appropriate keys.

   The left-hand side of the window shows the hierarchy of registry keys, and the right-hand side of the window shows various values associated with a key.

3. Double-click the parameter to edit.

   The String Editor dialog appears:

   Description of the illustration stringre.gif

4. Make any necessary edits.

5. Click OK.

6. Choose Exit from the Registry menu.

### 14.5.2 Adding a Registry Parameter with regedt

To add a parameter to the registry:

1. Start Registry Editor in one of two ways:

   - From the command prompt, enter:

         C:\> regedt

   - Choose Start `>` Run, enter `regedt` in the Open field, and click OK.

   The Registry Editor window appears.

2. Navigate to the key to which you want to add the new value.

3. Choose Add Value from the Edit menu.

   The Add Value dialog appears:

   Description of the illustration addvalue.gif

4. In the Value Name field, type the name of the value that you want to add to the currently selected key.

5. In the Data Type list, select the data type that you want to assign to the added value:

   - `REG_SZ`, `REG_EXPAND_SZ` (for an expandable string), or `REG_MULTI_SZ` (for multiple strings) for a data string

   - Binary value with a `REG_DWORD` prefix to identify a value entry as a `DWORD` (hexadecimal data) entry

6. Click OK.

   The String Editor dialog appears:

   Description of the illustration stringre.gif

7. Type the value for the parameter.

8. Click OK.

   Registry Editor adds the parameter.

9. Choose Exit from the Registry menu.

## 14.6 Managing Registry Parameters with Oracle Administration Assistant for Windows

Instead of using `regedt` to add, edit, and delete parameters for an Oracle home, you can use the Oracle Home Configuration snap-in, one of several snap-ins included as part of Oracle Administration Assistant for Windows. You must have Microsoft Management Console on your computer to use this product.

See Also: "HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\KEY_HOME_NAME" for more information about Oracle home parameters

### 14.6.1 Starting Oracle Administration Assistant for Windows

To start Oracle Administration Assistant for Windows:

1. Choose Start `>` Programs `>` Oracle - HOME_NAME `>` Configuration and Migration Tools `>` Administration Assistant for Windows.

   Oracle Administration Assistant for Windows starts.

2. Expand Oracle Homes.

3. Right-click the Oracle home that you want to modify.

   Description of the illustration admin1.gif

4. Click Properties. The Properties dialog appears.

   Description of the illustration admin2.gif

### 14.6.2 Adding Oracle Home Parameters

To add an Oracle home parameter:

1. Click Add in the Properties dialog.

   The Add Value dialog appears.

   Description of the illustration admin3.gif

2. Enter the name in the Parameter Name field.

3. Enter the value in the Parameter Value field.

4. Click OK.

5. Click Apply.

   Note: With Oracle Administration Assistant for Windows, you can add parameters only with a datatype of `REG_SZ`. Use `regedt` to add parameters with a datatype of `REG_EXPAND_SZ`, `REG_MULTI_SZ`, or `REG_DWORD`.

### 14.6.3 Editing Oracle Home Parameters

To change the default SID, select the SID from the Default SID list in the Properties dialog. To edit one of the other parameters:

1. Select the parameter in the Other Settings list in the Properties dialog.

2. Click Edit.

   Description of the illustration admin4.gif

   The Edit Value dialog appears.

   Description of the illustration admin5.gif

3. Modify the value.

4. Click OK.

5. Click Apply.

### 14.6.4 Deleting Oracle Home Parameters

To delete an Oracle home parameter:

1. Select the parameter in the Other Settings list in the Properties dialog.

2. Click Delete.

## 14.7 Modifying Oracle Counters for Windows Performance Monitor Parameters

Instead of using `regedt` to modify Oracle Counters for Windows Performance Monitor's `Hostname`, `Password`, and `Username` parameters, you can use operfcfg or Oracle Administration Assistant for Windows.

See Also: "Parameters for Oracle Counters for Windows Performance Monitor" for more information about `Hostname`, `Password`, and `Username` parameters

### 14.7.1 Using operfcfg

operfcfg is an Oracle Database tool that you run from the command prompt. Use this syntax:

    operfcfg [-U username] [-P password] [-D TNS_Alias_for_database]

where:

- `username` is the `username` registry parameter value that Oracle Counters for Windows Performance Monitor uses to log in to the database. You must have a `DBA` privilege on this database.

- `password` is the `password` registry parameter value for `username`.

- `TNS_Alias_for_database` is the net service name that Oracle Counters for Windows Performance Monitor uses to connect to the database. It affects the `Hostname` registry parameter. The net service name corresponds to the `SID` of the database that you want to monitor. The `-D` command can be specified without providing a database name value.

The `-U`, `-P`, and `-D` commands are all optional.

The following examples illustrate use of operfcfg. First, to change username to `dba_admin`, password to `frank`, and leave database name at its current value, you would enter:

    C:\> operfcfg -U dba_admin -P frank

To change username to `dba_admin`, password to `frank`, and database name to `prod`, you would enter:

    C:\> operfcfg -U dba_admin -P frank -D prod

To change password to `frank` for the current username and database name, you would enter:

    C:\> operfcfg -P frank

In the final example, you change `Hostname` to a blank value, causing Oracle Counters for Windows Performance Monitor to connect to the default database on the computer. The current username and password must be valid user accounts on this database. Enter:

    C:\> operfcfg -D

### 14.7.2 Using Oracle Administration Assistant for Windows

Oracle Counters for Windows Performance Monitor snap-in is part of Oracle Administration Assistant for Windows. You must have Microsoft Management Console on your computer in order to use this product.

To use Oracle Counters for Windows Performance Monitor snap-in:

1. Choose Start `>` Programs > Oracle - HOME_NAME `>` Configuration and Migration Tools `>` Administration Assistant for Windows.

   Oracle Administration Assistant for Windows starts.

2. Right-click Performance Monitor.

3. Click Properties.

   The Performance Monitor Properties dialog appears.

4. Modify the text in the Username, Password, or Database fields.

5. Click Apply.